<?php
$ispconfig_config_file = '/usr/local/ispconfig/server/lib/config.inc.php';
$pma_user = 'www-data';
$pma_group = 'www-data';
$pma_dir = '/var/www/apps/phpmyadmin';
$pma_config_file = $pma_dir.'/config.inc.php';
$pma_temdir = '/var/lib/th-phpmyadmin/tmp';
$pma_secrets_file = '/etc/th-phpmyadmin.inc.php';
$debian_pma_secrets_file = '/usr/share/phpmyadmin/config.inc.php';

function mkdirs($strPath, $mode = '0755'){
	// Verzeichnisse rekursiv erzeugen
	if(is_dir($strPath)) return true;
	$pStrPath = dirname($strPath);
	if(!mkdirs($pStrPath, $mode)) return false;
	$old_umask = umask(0);
	$ret_val = mkdir($strPath, octdec($mode));
	umask($old_umask);
	return $ret_val;
}

// blowfish secret & controll pass
if(file_exists($pma_secrets_file)){
	include($pma_secrets_file);
} else {
	$blowfish_secret = '';
	$controlpass = '';
	
	if(file_exists($debian_pma_secrets_file)){
		include($debian_pma_secrets_file);
		if(!empty($cfg['blowfish_secret'])){
			$blowfish_secret = $cfg['blowfish_secret'];
		}
		if(!empty($cfg['Servers'][1]['controlpass'])){
			$controlpass = $cfg['Servers'][1]['controlpass'];
		}
	}
	
	if(empty($blowfish_secret)){
		// blowfish secret
		exec('pwgen -snc 32 1', $output);
		$blowfish_secret = trim($output[0]);
		unset($output);
	}

	if(empty($controlpass)){
		// control pass
		exec('pwgen -snc '.rand(14,19).' 1', $output);
		$controlpass = trim($output[0]);
		unset($output);
	}
	
	$pma_secrets = '<?php
$blowfish_secret = \''.$blowfish_secret.'\';
$controlpass = \''.$controlpass.'\';';

	file_put_contents($pma_secrets_file, $pma_secrets);
	chmod($pma_secrets_file, 0600);
	chown($pma_secrets_file, 'root');
	chgrp($pma_secrets_file, 'root');
}

// control port
$controlport = 3306;

// host
$host = 'localhost';

// additional safe hosts
$additional_safe_hosts = '';

if(file_exists($ispconfig_config_file)){
	$pma_user = 'ispapps';
	$pma_group = 'ispapps';
	include($ispconfig_config_file);
	if(isset($conf['cloud2_identifier']) && intval($conf['cloud2_identifier']) > 10001 && intval($conf['cloud2_identifier']) % 2 == 0){
		$controlport = 3307;
		$host = 'db.c'.$conf['cloud2_identifier'].'.'.$conf['cloud2_domain'];
		$additional_safe_hosts .= ", '".$host."'";
	}
}

// create tmpdir
if(!is_dir($pma_temdir)){
	mkdirs($pma_temdir, '0775');
}
chown($pma_temdir, $pma_user);
chgrp($pma_temdir, $pma_group);

$trans = array(
	'{HOST}' => $host,
	'{CONTROLPORT}' => $controlport,
	'{CONTROLPASS}' => $controlpass,
	'{BLOWFISH_SECRET}' => $blowfish_secret,
	'{ADDITIONAL_SAFE_HOSTS}' => $additional_safe_hosts,
	'{CONTROLSECTION_START}' => '',
	'{CONTROLSECTION_END}' => ''
);

// Datenbankversion auslesen
$last_line = system("mysql -V", $retval);

if(empty($retval)){
	$last_line = trim($last_line);
	$dbversion = '0.0';
	$dbflavour = 'mariadb';
	if(!preg_match('/MariaDB/i', $last_line)){
		$dbflavour = 'mysql';
		if(preg_match('/Distrib (\d+\.\d+\.\d+)/i', $last_line, $matches)){
			$dbversion = $matches[1];
		}
	}
	//echo $dbflavour."\n";
	//echo $dbversion."\n";
	// CREATE USER IF NOT EXISTS wird nur auf MariaDB und MySQL >=5.7 unterstützt
	if($dbflavour == 'mariadb' || ($dbflavour == 'mysql' && version_compare($dbversion, '5.7', '>='))) {
		// import sql dump
		system('mysql --defaults-file=/etc/mysql/debian.cnf < '.$pma_dir.'/sql/create_tables.sql', $retval);
		if(!empty($retval)) exit($retval);
		system('mysql --defaults-file=/etc/mysql/debian.cnf -e "SHOW DATABASES;USE phpmyadmin;SHOW TABLES;"', $retval);
		if(!empty($retval)) exit($retval);

		// create phpmyadmin DB user
		system('mysql --defaults-file=/etc/mysql/debian.cnf -e "CREATE USER IF NOT EXISTS \'phpmyadmin\'@\'localhost\' IDENTIFIED BY \''.$controlpass.'\';"', $retval);
		if(!empty($retval)) exit($retval);
		system('mysql --defaults-file=/etc/mysql/debian.cnf -e "GRANT SELECT, INSERT, DELETE, UPDATE, ALTER ON phpmyadmin.* TO \'phpmyadmin\'@\'localhost\';"', $retval);
		if(!empty($retval)) exit($retval);
		system('mysql --defaults-file=/etc/mysql/debian.cnf -e "FLUSH PRIVILEGES;"', $retval);
		if(!empty($retval)) exit($retval);
	} else {
		$trans['{CONTROLSECTION_START}'] = '/*';
		$trans['{CONTROLSECTION_END}'] = '*/';
	}
}

$pma_config = file_get_contents($pma_config_file);
$pma_config = strtr($pma_config, $trans);
file_put_contents($pma_config_file, $pma_config);
chmod($pma_config_file, 0640);
system('chown -R '.escapeshellarg($pma_user).':'.escapeshellarg($pma_group).' '.escapeshellarg($pma_dir), $retval);
if(!empty($retval)) exit($retval);

// self-destroy
unlink(__FILE__);
exit(0);