<?php
/* vim: set expandtab sw=4 ts=4 sts=4: */
/**
 * Single signon for phpMyAdmin
 *
 * This is just example how to use session based single signon with
 * phpMyAdmin, it is not intended to be perfect code and look, only
 * shows how you can integrate this functionality in your application.
 *
 * @package    PhpMyAdmin
 * @subpackage Example
 */
//declare(strict_types=1);

/* Use cookies for session */
ini_set('session.use_cookies', 'true');
/* Change this to true if using phpMyAdmin over https */
$secure_cookie = true;
/* Need to have cookie visible from parent directory */
session_set_cookie_params(0, '/phpmyadmin/', '', $secure_cookie, true);
/* Create signon session */
$session_name = 'phpMyAdmin_https';
session_name($session_name);
// Uncomment and change the following line to match your $cfg['SessionSavePath']
//session_save_path('/foobar');
@session_start();

/* Was data posted? */
if (isset($_POST['user'])) {
	/* Store there credentials */
	$_SESSION['PMA_single_signon_user'] = trim($_POST['user']);
	$_SESSION['PMA_single_signon_password'] = (isset($_POST['password'])? trim($_POST['password']) : '');
	$_SESSION['PMA_single_signon_host'] = (isset($_POST['server']) && !empty(trim($_POST['server']))? trim($_POST['server']) : 'localhost');
	//$_SESSION['PMA_single_signon_host'] = (isset($_POST['port']) && !empty((int)trim($_POST['port']) && (int)trim($_POST['port']) != 3306)? '127.0.0.1' : 'localhost'); // falls man das server-Feld weglassen möchte, was bislang wg. der Cloud2 noch nicht geht.
	$_SESSION['PMA_single_signon_port'] = (isset($_POST['port']) && !empty((int)trim($_POST['port']))? (int)trim($_POST['port']) : 3306);
	/* Update another field of server configuration */
	//$_SESSION['PMA_single_signon_cfgupdate'] = ['verbose' => 'Signon test'];
	$_SESSION['PMA_single_signon_HMAC_secret'] = hash('sha1', uniqid(strval(rand()), true));
	$id = session_id();
	/* Close that session */
	@session_write_close();
	/* Redirect to phpMyAdmin (should use absolute URL here!) */
	header('Location: index.php');
} else {
	/* Show simple form */
	header('Content-Type: text/html; charset=utf-8');
	header("Content-Security-Policy: style-src 'self' 'unsafe-inline'; script-src 'self' 'unsafe-inline' 'unsafe-eval'; worker-src 'self' blob:; frame-src 'self'; object-src 'none';");
	header("X-Content-Type-Options: nosniff");
	header("X-XSS-Protection: 1; mode=block");
	header("X-Frame-Options: SAMEORIGIN");
	echo '<?xml version="1.0" encoding="utf-8"?>' , "\n";
?>
<!DOCTYPE HTML>
<html lang="de" dir="ltr">
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
		<meta name="referrer" content="no-referrer">
		<meta name="robots" content="noindex,nofollow">
		<meta http-equiv="X-UA-Compatible" content="IE=Edge">
		<link rel="icon" href="favicon.ico" type="image/x-icon">
		<link rel="shortcut icon" href="favicon.ico" type="image/x-icon">
		<link rel="stylesheet" type="text/css" href="./themes/pmahomme/css/theme.css?v=5.2.1&nocache=<?php echo md5(uniqid(microtime(), 1)); ?>&server=1">
		<script data-cfasync="false" type="text/javascript" src="js/vendor/jquery/jquery.min.js?v=5.2.1"></script>
		<title>phpMyAdmin</title>
		<noscript><style>html{display:block}</style></noscript>
	</head>
	<body id="loginform">
			
		<div id="page_content">
			<div class="container">
				<div class="row">
					<div class="col-12">
						<a href="./url.php?url=https%3A%2F%2Fwww.phpmyadmin.net%2F" target="_blank" rel="noopener noreferrer" class="logo">
						<img src="./themes/pmahomme/img/logo_right.png" id="imLogo" name="imLogo" alt="phpMyAdmin" border="0">
						</a>
						<h1><span id="welcome">Willkommen bei</span> <bdo dir="ltr" lang="en">phpMyAdmin</bdo></h1>
						<noscript>
							<div class="alert alert-danger" role="alert">
								<img src="themes/dot.gif" title="" alt="" class="icon ic_s_error"> Javascript muss ab hier aktiviert sein!
							</div>
						</noscript>
						<?php
							if (!empty($_SESSION['PMA_single_signon_error_message'])) {
								echo '<div class="alert alert-danger" role="alert"><img src="themes/dot.gif" title="" alt="" class="icon ic_s_error">';
								echo $_SESSION['PMA_single_signon_error_message'];
								echo '</div>';
							}
						?>
						<br />
						<!-- Login form -->
						<form method="post" id="login_form" action="signon.php" name="login_form">
							<div class="card mb-4">
								<div class="card-header">
								<span id="login">Anmeldung</span>      <a href="./doc/html/index.html" target="documentation"><img src="themes/dot.gif" title="Dokumentation" alt="Dokumentation" class="icon ic_b_help"></a>
								</div>
								<div class="card-body">
									<div class="row mb-3">
										<label for="input_username" class="col-sm-4 col-form-label">
										<span id="username">Benutzername</span>:        </label>
										<div class="col-sm-8">
											<input type="text" name="user" id="input_username" value="<?php echo (!empty($_REQUEST['user'])? htmlspecialchars(trim($_REQUEST['user'])):''); ?>" class="form-control" autocomplete="username" placeholder="Datenbank-Benutzer">
										</div>
									</div>
									<div class="row">
										<label for="input_password" class="col-sm-4 col-form-label">
										<span id="password">Passwort</span>:        </label>
										<div class="col-sm-8">
											<input type="password" name="password" id="input_password" value="" class="form-control" autocomplete="current-password">
										</div>
									</div>
									<div class="row">
										<label for="input_host" class="col-sm-4 col-form-label">
										Server:        </label>
										<div class="col-sm-8">
											<input type="text" name="server" id="input_host" value="<?php echo (!empty($_REQUEST['server'])? htmlspecialchars(trim($_REQUEST['server'])):''); ?>" class="form-control" placeholder="Nur benötigt, falls nicht localhost">
										</div>
									</div>
									
									<div class="row">
										<label for="input_port" class="col-sm-4 col-form-label">
										Port:        </label>
										<div class="col-sm-8">
											<input type="text" name="port" id="input_port" value="<?php echo (!empty($_REQUEST['port'])? htmlspecialchars(trim($_REQUEST['port'])):''); ?>" class="form-control" placeholder="Nur benötigt, falls nicht 3306">
										</div>
									</div>
								</div>
								<div class="card-footer">
									<input class="btn btn-primary" value="Anmeldung" type="submit" id="input_go">
								</div>
							</div>
						</form>
						<br />
						<?php
							if (!empty($_SESSION['PMA_single_signon_error_message'])) {
								echo '<div class="alert alert-danger" role="alert"><img src="themes/dot.gif" title="" alt="" class="icon ic_s_error">';
								echo $_SESSION['PMA_single_signon_error_message'];
								echo '</div>';
							}
						?>
					</div>
				</div>
			</div>
		</div>
		<script language="JavaScript" type="text/javascript">
			var userLang = navigator.language || navigator.userLanguage;
			userLang = userLang.split('-')[0];
			if(userLang != 'de'){
				$('#welcome').text('Welcome to');
				$('#login').text('Login');
				$('#input_go').val('Login');
				$('#username').text('Username');
				$('#input_username').attr('placeholder', 'Database User');
				$('#password').text('Password');
				$('#input_host').attr('placeholder', 'Only needed if not localhost');
				$('#input_port').attr('placeholder', 'Only needed if not 3306');
			}
		</script>
	</body>
</html>
<?php
}
?>